package spec.benchmarks._201_compress;
final class Compressor extends Comp_Base {
    private final static int 	CHECK_GAP = 10000;
    private int 	ratio;
    private int 	checkpoint;
    private int 	in_count;
    private int 	out_count;
    private int 	bytes_out;
    private Hash_Table 	htab;
    private Code_Table 	codetab;
    public  	Compressor(Input_Buffer in,Output_Buffer out) {
	super(in,out);
// 252 "Compress.jgo"
	if (maxbits < Compress.INIT_BITS) maxbits = Compress.INIT_BITS;
// 253 "Compress.jgo"
	if (maxbits > Compress.BITS) maxbits = Compress.BITS;
	maxmaxcode = 1 << maxbits;
	n_bits = Compress.INIT_BITS;
	maxcode = MAXCODE();
	offset = 0;
	bytes_out = 3;
	out_count = 0;
	clear_flg = 0;
	ratio = 0;
	in_count = 1;
	checkpoint = CHECK_GAP;
	free_ent = ((block_compress != 0)?Compress.FIRST:256);
	htab = new Hash_Table();
	codetab = new Code_Table();
	Output.putbyte(Compress.magic_header[0]);
	Output.putbyte(Compress.magic_header[1]);
	Output.putbyte((byte)(maxbits | block_compress));
    }
    public void 	compress(javago.StackFrame M_ParentState) {
	STCompressorcompress 	M_State = null;
	STCompressorcompress 	M_OldState = null;
	int 	M_EntryPoint = 0;
	int 	temphtab = 0;
	int 	hshift = 0;
	int 	hsize_reg = 0;
	int 	disp = 0;
	int 	ent = 0;
	int 	c = 0;
	int 	i = 0;
	int 	fcode = 0;
	int 	tmp1 = 0;
	int 	tmp2 = 0;
	int 	tmp3 = 0;
	int 	tmp4 = 0;
	int 	tmp5 = 0;
	int 	tmp6 = 0;
	int 	tmp7 = 0;
	if (M_ParentState == null) {
	    M_State = null;
	    M_EntryPoint = 0;
	}
	else {
	    M_State = (STCompressorcompress)M_ParentState.Child;
	    tmp7 = M_State.tmp7;
	    tmp6 = M_State.tmp6;
	    tmp5 = M_State.tmp5;
	    tmp4 = M_State.tmp4;
	    tmp3 = M_State.tmp3;
	    tmp2 = M_State.tmp2;
	    tmp1 = M_State.tmp1;
	    fcode = M_State.fcode;
	    i = M_State.i;
	    c = M_State.c;
	    ent = M_State.ent;
	    disp = M_State.disp;
	    hsize_reg = M_State.hsize_reg;
	    hshift = M_State.hshift;
	    temphtab = M_State.temphtab;
	    M_EntryPoint = M_State.M_EntryPoint;
	}
	{
	 M_TopLevel:
	    for( ;; ) switch (M_EntryPoint) {
		case 0:
		case 1:
		    i = 0;
		    ent = Input.getbyte();
		    hshift = 0;
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 7;
		case 7:
		    tmp1 = htab.hsize(M_State);
		    fcode = tmp1;
// 287 "Compress.jgo"
		    for( ; fcode < 65536; fcode *= 2 ) hshift++;
		    hshift = 8 - hshift;
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 14;
		case 14:
		    tmp2 = htab.hsize(M_State);
		    hsize_reg = tmp2;
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 19;
		case 19:
		    htab.clear(M_State);
		case 20:
// 294 "Compress.jgo"
		 next_byte:
// 295 "Compress.jgo"
		    while ( (c = Input.getbyte()) != -1 ) {
			in_count++;
			fcode = (((int)c << maxbits) + ent);
			i = ((c << hshift) ^ ent);
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 39;
			tmp3 = htab.of(M_State,i);
			temphtab = tmp3;
// 301 "Compress.jgo"
			if (temphtab == fcode) {
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 59;
			    tmp4 = codetab.of(M_State,i);
			    ent = tmp4;
			    M_EntryPoint = 20;
			    continue M_TopLevel;
			}
// 307 "Compress.jgo"
			if (temphtab >= 0) {
			    disp = hsize_reg - i;
// 309 "Compress.jgo"
			    if (i == 0) disp = 1;
// 312 "Compress.jgo"
			    do {
// 313 "Compress.jgo"
				if ((i -= disp) < 0) i += hsize_reg;
				M_OldState = M_State;
				M_State = null;
				M_EntryPoint = 86;
				tmp5 = htab.of(M_State,i);
				temphtab = tmp5;
// 319 "Compress.jgo"
				if (temphtab == fcode) {
				    M_OldState = M_State;
				    M_State = null;
				    M_EntryPoint = 94;
				    tmp6 = codetab.of(M_State,i);
				    ent = tmp6;
				    M_EntryPoint = 20;
				    continue M_TopLevel;
				}
			    }
			    while ( temphtab > 0 );
			}
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 46;
			output(M_State,ent);
			out_count++;
			ent = c;
// 330 "Compress.jgo"
			if (free_ent < maxmaxcode) {
			    tmp7 = free_ent;
			    free_ent++;
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 70;
			    codetab.set(M_State,i,tmp7);
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 74;
			    htab.set(M_State,i,fcode);
			}
			else if ((in_count >= checkpoint) && (block_compress != 0)) {
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 81;
			    cl_block(M_State);
			}
		    }
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 24;
		case 24:
		    output(M_State,ent);
		    out_count++;
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 29;
		case 29:
		    output(M_State,-1);
// 344 "Compress.jgo"
		    return;
		case 32:
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		    tmp3 = htab.of(M_State,i);
		    temphtab = tmp3;
// 301 "Compress.jgo"
		    if (temphtab == fcode) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 59;
			tmp4 = codetab.of(M_State,i);
			ent = tmp4;
			M_EntryPoint = 20;
			continue M_TopLevel;
		    }
		case 42:
// 307 "Compress.jgo"
		    if (temphtab >= 0) {
			disp = hsize_reg - i;
// 309 "Compress.jgo"
			if (i == 0) disp = 1;
// 312 "Compress.jgo"
			do {
// 313 "Compress.jgo"
			    if ((i -= disp) < 0) i += hsize_reg;
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 86;
			    tmp5 = htab.of(M_State,i);
			    temphtab = tmp5;
// 319 "Compress.jgo"
			    if (temphtab == fcode) {
				M_OldState = M_State;
				M_State = null;
				M_EntryPoint = 94;
				tmp6 = codetab.of(M_State,i);
				ent = tmp6;
				M_EntryPoint = 20;
				continue M_TopLevel;
			    }
			}
			while ( temphtab > 0 );
		    }
		case 43:
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 46;
		case 46:
		    output(M_State,ent);
		    out_count++;
		    ent = c;
// 330 "Compress.jgo"
		    if (free_ent < maxmaxcode) {
			tmp7 = free_ent;
			free_ent++;
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 70;
			codetab.set(M_State,i,tmp7);
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 74;
			htab.set(M_State,i,fcode);
		    }
		    else if ((in_count >= checkpoint) && (block_compress != 0)) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 81;
			cl_block(M_State);
		    }
		    M_EntryPoint = 20;
		    continue M_TopLevel;
		case 50:
		case 51:
		case 52:
		case 53:
		case 54:
		case 55:
		case 56:
		case 57:
		case 58:
		case 59:
		    tmp4 = codetab.of(M_State,i);
		    ent = tmp4;
		    M_EntryPoint = 20;
		    continue M_TopLevel;
		case 62:
		case 63:
		case 64:
// 312 "Compress.jgo"
		    do {
// 313 "Compress.jgo"
			if ((i -= disp) < 0) i += hsize_reg;
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 86;
			tmp5 = htab.of(M_State,i);
			temphtab = tmp5;
// 319 "Compress.jgo"
			if (temphtab == fcode) {
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 94;
			    tmp6 = codetab.of(M_State,i);
			    ent = tmp6;
			    M_EntryPoint = 20;
			    continue M_TopLevel;
			}
		    }
		    while ( temphtab > 0 );
		    M_EntryPoint = 43;
		    continue M_TopLevel;
		case 65:
		case 66:
		case 67:
		case 68:
		case 69:
		case 70:
		    codetab.set(M_State,i,tmp7);
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 74;
		case 74:
		    htab.set(M_State,i,fcode);
		    M_EntryPoint = 20;
		    continue M_TopLevel;
		case 75:
		case 76:
		case 77:
		case 78:
		case 79:
		case 80:
		case 81:
		    cl_block(M_State);
		    M_EntryPoint = 20;
		    continue M_TopLevel;
		case 82:
		case 83:
		case 84:
		case 85:
		case 86:
		    tmp5 = htab.of(M_State,i);
		    temphtab = tmp5;
// 319 "Compress.jgo"
		    if (temphtab == fcode) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 94;
			tmp6 = codetab.of(M_State,i);
			ent = tmp6;
			M_EntryPoint = 20;
			continue M_TopLevel;
		    }
		    M_EntryPoint = 64;
		    continue M_TopLevel;
		case 89:
		case 90:
		case 91:
		case 92:
		case 93:
		case 94:
		    tmp6 = codetab.of(M_State,i);
		    ent = tmp6;
		    M_EntryPoint = 20;
		    continue M_TopLevel;
	    }
	}
    }
    public void 	output(javago.StackFrame M_ParentState,int code) {
	STCompressoroutputi 	M_State = null;
	STCompressoroutputi 	M_OldState = null;
	int 	M_EntryPoint = 0;
	int 	bp = 0;
	int 	bits = 0;
	int 	r_off = 0;
	int 	tmp1 = 0;
	if (M_ParentState == null) {
	    M_State = null;
	    M_EntryPoint = 0;
	}
	else {
	    M_State = (STCompressoroutputi)M_ParentState.Child;
	    tmp1 = M_State.tmp1;
	    code = M_State.code;
	    r_off = M_State.r_off;
	    bits = M_State.bits;
	    bp = M_State.bp;
	    M_EntryPoint = M_State.M_EntryPoint;
	}
	{
	 M_TopLevel:
	    for( ;; ) switch (M_EntryPoint) {
		case 0:
		case 1:
		    bits = n_bits;
		    r_off = offset;
		    bp = 0;
// 365 "Compress.jgo"
		    if (code >= 0) {
			bp += (r_off >> 3);
			r_off &= 7;
			buf[bp] = (byte)((buf[bp] & Compress.rmask[r_off]) | (code << r_off) & Compress.lmask[r_off]);
			bp++;
			bits -= (8 - r_off);
			code >>= 8 - r_off;
// 381 "Compress.jgo"
			if (bits >= 8) {
			    buf[bp++] = (byte)code;
			    code >>= 8;
			    bits -= 8;
			}
// 387 "Compress.jgo"
			if (bits != 0) buf[bp] = (byte)code;
			offset += n_bits;
// 390 "Compress.jgo"
			if (offset == (n_bits << 3)) {
			    bp = 0;
			    bits = n_bits;
			    bytes_out += bits;
// 394 "Compress.jgo"
			    do Output.putbyte(buf[bp++]);
			    while ( --bits != 0 );
			    offset = 0;
			}
// 404 "Compress.jgo"
			if (free_ent > maxcode || (clear_flg > 0)) {
// 409 "Compress.jgo"
			    if (offset > 0) {
				M_OldState = M_State;
				M_State = null;
				M_EntryPoint = 39;
				Output.writebytes(M_State,buf,n_bits);
				bytes_out += n_bits;
			    }
			    offset = 0;
// 415 "Compress.jgo"
			    if (clear_flg != 0) {
				n_bits = Compress.INIT_BITS;
				maxcode = MAXCODE();
				clear_flg = 0;
			    }
			    else {
				n_bits++;
// 422 "Compress.jgo"
				if (n_bits == maxbits) maxcode = maxmaxcode;
				else maxcode = MAXCODE();
			    }
			}
		    }
		    else {
// 432 "Compress.jgo"
			if (offset > 0) {
			    tmp1 = (offset + 7) / 8;
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 33;
			    Output.writebytes(M_State,buf,tmp1);
			}
			bytes_out += (offset + 7) / 8;
			offset = 0;
		    }
		case 5:
		    return;
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19:
		case 20:
		    bytes_out += (offset + 7) / 8;
		    offset = 0;
		    M_EntryPoint = 5;
		    continue M_TopLevel;
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27:
		    offset = 0;
// 415 "Compress.jgo"
		    if (clear_flg != 0) {
			n_bits = Compress.INIT_BITS;
			maxcode = MAXCODE();
			clear_flg = 0;
		    }
		    else {
			n_bits++;
// 422 "Compress.jgo"
			if (n_bits == maxbits) maxcode = maxmaxcode;
			else maxcode = MAXCODE();
		    }
		    M_EntryPoint = 5;
		    continue M_TopLevel;
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		    Output.writebytes(M_State,buf,tmp1);
		    M_EntryPoint = 20;
		    continue M_TopLevel;
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		    Output.writebytes(M_State,buf,n_bits);
		    bytes_out += n_bits;
		    M_EntryPoint = 27;
		    continue M_TopLevel;
	    }
	}
    }
    public void 	cl_block(javago.StackFrame M_ParentState) {
	STCompressorcl_block 	M_State = null;
	STCompressorcl_block 	M_OldState = null;
	int 	M_EntryPoint = 0;
	int 	rat = 0;
	if (M_ParentState == null) {
	    M_State = null;
	    M_EntryPoint = 0;
	}
	else {
	    M_State = (STCompressorcl_block)M_ParentState.Child;
	    rat = M_State.rat;
	    M_EntryPoint = M_State.M_EntryPoint;
	}
	{
	 M_TopLevel:
	    for( ;; ) switch (M_EntryPoint) {
		case 0:
		case 1:
		    checkpoint = in_count + CHECK_GAP;
// 446 "Compress.jgo"
		    if (in_count > 0x007fffff) {
			rat = bytes_out >> 8;
// 448 "Compress.jgo"
			if (rat == 0) rat = 0x7fffffff;
			else rat = in_count / rat;
		    }
		    else rat = (in_count << 8) / bytes_out;
// 456 "Compress.jgo"
		    if (rat > ratio) ratio = rat;
		    else {
			ratio = 0;
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 11;
			htab.clear(M_State);
			free_ent = Compress.FIRST;
			clear_flg = 1;
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 17;
			output(M_State,(int)Compress.CLEAR);
		    }
		case 4:
		    return;
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		    htab.clear(M_State);
		    free_ent = Compress.FIRST;
		    clear_flg = 1;
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 17;
		case 17:
		    output(M_State,(int)Compress.CLEAR);
		    M_EntryPoint = 4;
		    continue M_TopLevel;
	    }
	}
    }
}
