package spec.benchmarks._201_compress;
final class Decompressor extends Comp_Base {
    private int 	size;
    private Code_Table 	tab_prefix;
    private Suffix_Table 	tab_suffix;
    private De_Stack 	de_stack;
    public  	Decompressor(Input_Buffer in,Output_Buffer out) {
	super(in,out);
// 523 "Compress.jgo"
	if (((Input.getbyte() & 0xFF) != (Compress.magic_header[0] & 0xFF)) || ((Input.getbyte() & 0xFF) != (Compress.magic_header[1] & 0xFF))) System.err.println("stdin: not in compressed format");
	maxbits = Input.getbyte();
	block_compress = maxbits & Compress.BLOCK_MASK;
	maxbits &= Compress.BIT_MASK;
	maxmaxcode = 1 << maxbits;
// 533 "Compress.jgo"
	if (maxbits > Compress.BITS) System.err.println("stdin: compressed with " + maxbits + " bits, can only handle " + Compress.BITS + " bits");
	n_bits = Compress.INIT_BITS;
	maxcode = MAXCODE();
	offset = 0;
	size = 0;
	clear_flg = 0;
	free_ent = ((block_compress != 0)?Compress.FIRST:256);
	tab_prefix = new Code_Table();
	tab_suffix = new Suffix_Table();
	de_stack = new De_Stack();
	tab_prefix.clear(256);
	tab_suffix.init(256);
    }
    public void 	decompress(javago.StackFrame M_ParentState) {
	STDecompressordecompress 	M_State = null;
	STDecompressordecompress 	M_OldState = null;
	int 	M_EntryPoint = 0;
	int 	incode = 0;
	int 	oldcode = 0;
	int 	code = 0;
	int 	finchar = 0;
	int 	tmp1 = 0;
	int 	tmp2 = 0;
	int 	tmp3 = 0;
	byte 	tmp4 = 0;
	int 	tmp5 = 0;
	byte 	tmp6 = 0;
	byte 	tmp7 = 0;
	boolean 	tmp8 = false;
	if (M_ParentState == null) {
	    M_State = null;
	    M_EntryPoint = 0;
	}
	else {
	    M_State = (STDecompressordecompress)M_ParentState.Child;
	    tmp8 = M_State.tmp8;
	    tmp7 = M_State.tmp7;
	    tmp6 = M_State.tmp6;
	    tmp5 = M_State.tmp5;
	    tmp4 = M_State.tmp4;
	    tmp3 = M_State.tmp3;
	    tmp2 = M_State.tmp2;
	    tmp1 = M_State.tmp1;
	    finchar = M_State.finchar;
	    code = M_State.code;
	    oldcode = M_State.oldcode;
	    incode = M_State.incode;
	    M_EntryPoint = M_State.M_EntryPoint;
	}
	{
	 M_TopLevel:
	    for( ;; ) switch (M_EntryPoint) {
		case 0:
		case 1:
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 4;
		case 4:
		    tmp1 = getcode(M_State);
		    oldcode = tmp1;
		    finchar = oldcode;
// 564 "Compress.jgo"
		    if (oldcode == -1) return;
		    Output.putbyte((byte)finchar);
		case 9:
// 569 "Compress.jgo"
		    while ( true ) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 15;
			tmp2 = getcode(M_State);
			code = tmp2;
// 571 "Compress.jgo"
			if (code <= -1) {
			    M_EntryPoint = 10;
			    continue M_TopLevel;
			}
// 573 "Compress.jgo"
			if ((code == Compress.CLEAR) && (block_compress != 0)) {
			    tab_prefix.clear(256);
			    clear_flg = 1;
			    free_ent = Compress.FIRST - 1;
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 48;
			    tmp3 = getcode(M_State);
			    code = tmp3;
// 577 "Compress.jgo"
			    if (code == -1) {
				M_EntryPoint = 10;
				continue M_TopLevel;
			    }
			}
			incode = code;
// 584 "Compress.jgo"
			if (code >= free_ent) {
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 54;
			    de_stack.push(M_State,(byte)finchar);
			    code = oldcode;
			}
// 592 "Compress.jgo"
			while ( code >= 256 ) {
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 59;
			    tmp4 = tab_suffix.of(M_State,code);
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 63;
			    de_stack.push(M_State,tmp4);
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 67;
			    tmp5 = tab_prefix.of(M_State,code);
			    code = tmp5;
			}
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 25;
			tmp6 = tab_suffix.of(M_State,code);
			finchar = tmp6;
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 30;
			de_stack.push(M_State,(byte)finchar);
// 607 "Compress.jgo"
			while ( true ) {
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 72;
			    tmp7 = de_stack.pop(M_State);
			    Output.putbyte(tmp7);
			    M_OldState = M_State;
			    M_State = null;
			    M_EntryPoint = 77;
			    tmp8 = de_stack.is_empty(M_State);
// 609 "Compress.jgo"
			    if (tmp8) {
				M_EntryPoint = 32;
				continue M_TopLevel;
			    }
			}
		    }
		case 10:
		    return;
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		    tmp2 = getcode(M_State);
		    code = tmp2;
// 571 "Compress.jgo"
		    if (code <= -1) {
			M_EntryPoint = 10;
			continue M_TopLevel;
		    }
// 573 "Compress.jgo"
		    if ((code == Compress.CLEAR) && (block_compress != 0)) {
			tab_prefix.clear(256);
			clear_flg = 1;
			free_ent = Compress.FIRST - 1;
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 48;
			tmp3 = getcode(M_State);
			code = tmp3;
// 577 "Compress.jgo"
			if (code == -1) {
			    M_EntryPoint = 10;
			    continue M_TopLevel;
			}
		    }
		case 19:
		    incode = code;
// 584 "Compress.jgo"
		    if (code >= free_ent) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 54;
			de_stack.push(M_State,(byte)finchar);
			code = oldcode;
		    }
		case 21:
// 592 "Compress.jgo"
		    while ( code >= 256 ) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 59;
			tmp4 = tab_suffix.of(M_State,code);
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 63;
			de_stack.push(M_State,tmp4);
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 67;
			tmp5 = tab_prefix.of(M_State,code);
			code = tmp5;
		    }
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 25;
		case 25:
		    tmp6 = tab_suffix.of(M_State,code);
		    finchar = tmp6;
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 30;
		case 30:
		    de_stack.push(M_State,(byte)finchar);
		case 31:
// 607 "Compress.jgo"
		    while ( true ) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 72;
			tmp7 = de_stack.pop(M_State);
			Output.putbyte(tmp7);
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 77;
			tmp8 = de_stack.is_empty(M_State);
// 609 "Compress.jgo"
			if (tmp8) {
			    M_EntryPoint = 32;
			    continue M_TopLevel;
			}
		    }
		case 32:
// 617 "Compress.jgo"
		    if ((code = free_ent) < maxmaxcode) {
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 82;
			tab_prefix.set(M_State,code,oldcode);
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 86;
			tab_suffix.set(M_State,code,(byte)finchar);
			free_ent = code + 1;
		    }
		case 33:
		    oldcode = incode;
		    M_EntryPoint = 9;
		    continue M_TopLevel;
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		case 40:
		case 41:
		case 42:
		case 43:
		case 44:
		case 45:
		case 46:
		case 47:
		case 48:
		    tmp3 = getcode(M_State);
		    code = tmp3;
// 577 "Compress.jgo"
		    if (code == -1) {
			M_EntryPoint = 10;
			continue M_TopLevel;
		    }
		    M_EntryPoint = 19;
		    continue M_TopLevel;
		case 51:
		case 52:
		case 53:
		case 54:
		    de_stack.push(M_State,(byte)finchar);
		    code = oldcode;
		    M_EntryPoint = 21;
		    continue M_TopLevel;
		case 56:
		case 57:
		case 58:
		case 59:
		    tmp4 = tab_suffix.of(M_State,code);
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 63;
		case 63:
		    de_stack.push(M_State,tmp4);
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 67;
		case 67:
		    tmp5 = tab_prefix.of(M_State,code);
		    code = tmp5;
		    M_EntryPoint = 21;
		    continue M_TopLevel;
		case 69:
		case 70:
		case 71:
		case 72:
		    tmp7 = de_stack.pop(M_State);
		    Output.putbyte(tmp7);
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 77;
		case 77:
		    tmp8 = de_stack.is_empty(M_State);
// 609 "Compress.jgo"
		    if (tmp8) {
			M_EntryPoint = 32;
			continue M_TopLevel;
		    }
		    M_EntryPoint = 31;
		    continue M_TopLevel;
		case 79:
		case 80:
		case 81:
		case 82:
		    tab_prefix.set(M_State,code,oldcode);
		    M_OldState = M_State;
		    M_State = null;
		    M_EntryPoint = 86;
		case 86:
		    tab_suffix.set(M_State,code,(byte)finchar);
		    free_ent = code + 1;
		    M_EntryPoint = 33;
		    continue M_TopLevel;
	    }
	}
    }
    public int 	getcode(javago.StackFrame M_ParentState) {
	STDecompressorgetcode 	M_State = null;
	STDecompressorgetcode 	M_OldState = null;
	int 	M_EntryPoint = 0;
	int 	bp = 0;
	int 	bits = 0;
	int 	r_off = 0;
	int 	code = 0;
	int 	tmp1 = 0;
	if (M_ParentState == null) {
	    M_State = null;
	    M_EntryPoint = 0;
	}
	else {
	    M_State = (STDecompressorgetcode)M_ParentState.Child;
	    tmp1 = M_State.tmp1;
	    code = M_State.code;
	    r_off = M_State.r_off;
	    bits = M_State.bits;
	    bp = M_State.bp;
	    M_EntryPoint = M_State.M_EntryPoint;
	}
	{
	 M_TopLevel:
	    for( ;; ) switch (M_EntryPoint) {
		case 0:
		case 1:
		    bp = 0;
// 642 "Compress.jgo"
		    if (clear_flg > 0 || offset >= size || free_ent > maxcode) {
// 648 "Compress.jgo"
			if (free_ent > maxcode) {
			    n_bits++;
// 650 "Compress.jgo"
			    if (n_bits == maxbits) maxcode = maxmaxcode;
			    else maxcode = MAXCODE();
			}
// 655 "Compress.jgo"
			if (clear_flg > 0) {
			    n_bits = Compress.INIT_BITS;
			    maxcode = MAXCODE();
			    clear_flg = 0;
			}
			M_OldState = M_State;
			M_State = null;
			M_EntryPoint = 22;
			tmp1 = Input.readbytes(M_State,buf,n_bits);
			size = tmp1;
// 661 "Compress.jgo"
			if (size <= 0) return -1;
			offset = 0;
			size = (size << 3) - (n_bits - 1);
		    }
		case 3:
		    r_off = offset;
		    bits = n_bits;
		    bp += (r_off >> 3);
		    r_off &= 7;
		    code = ((buf[bp++] >> r_off) & Compress.rmask[8 - r_off]) & 0xff;
		    bits -= (8 - r_off);
		    r_off = 8 - r_off;
// 679 "Compress.jgo"
		    if (bits >= 8) {
			code |= (buf[bp++] & 0xff) << r_off;
			r_off += 8;
			bits -= 8;
		    }
// 687 "Compress.jgo"
		    if (bits > 0) code |= (buf[bp] & Compress.rmask[bits]) << r_off;
		    offset += n_bits;
// 690 "Compress.jgo"
		    return code;
		case 15:
		case 16:
		case 17:
		case 18:
		case 19:
		case 20:
		case 21:
		case 22:
		    tmp1 = Input.readbytes(M_State,buf,n_bits);
		    size = tmp1;
// 661 "Compress.jgo"
		    if (size <= 0) return -1;
		    offset = 0;
		    size = (size << 3) - (n_bits - 1);
		    M_EntryPoint = 3;
		    continue M_TopLevel;
	    }
	}
    }
}
